-----------------------------------------------------------------------------------------------
-- Client Lua Script for GameReadySound
-- Created by Caleb, All rights reserved
-----------------------------------------------------------------------------------------------
require "Sound"

local setmetatable = setmetatable
local Apollo = Apollo
local Sound = Sound

local GameReadySound = {}

function GameReadySound:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function GameReadySound:Init()
    Apollo.RegisterAddon(self)
	self.nVolumeMaster = nil
	self.nVolumeVoice = nil
	self.bVolumeReset = false
end

function GameReadySound:OnLoad()
	Apollo.RegisterEventHandler("MatchingGameReady", "OnGameReady", self)
end

function GameReadySound:MaxVolumesAndPlaySound(soundIndex)
	self.nVolumeMaster = Apollo.GetConsoleVariable("sound.volumeMaster")
	self.nVolumeVoice = Apollo.GetConsoleVariable("sound.volumeVoice")
	Apollo.SetConsoleVariable("sound.volumeMaster", 1)
	Apollo.SetConsoleVariable("sound.volumeVoice", 1)
	Sound.Play(soundIndex) -- Challange Begins
	self.bVolumeReset = false
	Apollo.CreateTimer("sRestoreVolumeTimer", 4, false)
	Apollo.RegisterTimerHandler("sRestoreVolumeTimer", "RestoreVolumeTimer", self)
	Apollo.StartTimer("sRestoreVolumeTimer")
end

function GameReadySound:RestoreVolumeTimer()
	if not self.bVolumeReset then
		Apollo.SetConsoleVariable("sound.volumeMaster", self.nVolumeMaster)
		Apollo.SetConsoleVariable("sound.volumeVoice", self.nVolumeVoice)
		self.bVolumeReset = true
		Apollo.StopTimer("sRestoreVolumeTimer")
	end
end

function GameReadySound:OnGameReady(inProgress)
	GameReadySound:MaxVolumesAndPlaySound(166)
end

local GameReadySoundInst = GameReadySound:new()
GameReadySoundInst:Init()

